<template>
  <div
    class="tiny-user-center"
    :class="{ 'has-unread-message': isHasUnreadMessage }"
  >
    <div
      class="flex items-center justify-center tiny-button"
      :class="{ 'tiny-button-rotate': isTinyUserCenterEnabled }"
      @click="tiggerTinyUserCenter"
    >
      <div class="w-[12.67px] flex place-content-between">
        <div v-for="item in 3" :key="item" class="tiny-dot"></div>
      </div>
    </div>
    <div
      class="rounded-l-full user-center-container pr-4 -m-4"
      :class="{ 'user-center-container-active': isTinyUserCenterEnabled }"
    >
      <div class="relative" :class="{ 'w-[300px]': !auth }">
        <div class="flex pl-2.5" :class="{ 'custom-backdrop-blur': !auth }">
          <div
            v-for="(tab, index) in tabs"
            :key="index"
            class="flex flex-nowrap items-center justify-center"
          >
            <NuxtLink :to="tab.to" class="p-1">
              <el-tooltip
                popper-class="tiny-user-center-tooltip"
                :hide-after="0"
                effect="dark"
                :content="$t(tab.label)"
                placement="bottom"
              >
                <div class="relative">
                  <SvgIcon
                    class="w-[20px] h-[20px] m-0.5"
                    :svg-name="tab.icon"
                  />
                  <span
                    :class="{
                      'tiny-dot-unread-message':
                        tab.label === 'messages' && isHasUnreadMessage,
                    }"
                  ></span>
                </div>
              </el-tooltip>
              <!-- <div class="max-w-0 overflow-hidden user-center-label uppercase">
                <span class="pl-1 text-[10px]">{{ $t(tab.label) }}</span>
              </div> -->
            </NuxtLink>
            <div class="w-[1px] h-4 bg-[var(--border)]"></div>
          </div>
          <div class="px-1 flex flex-nowrap items-center justify-center">
            <el-tooltip
              popper-class="tiny-user-center-tooltip"
              :hide-after="0"
              effect="dark"
              :content="$t('logout')"
              placement="bottom"
            >
              <SvgIcon
                class="w-[20px] h-[20px] m-0.5 cursor-pointer"
                svg-name="icon-sign-out"
                @click="logout"
              />
            </el-tooltip>
            <!-- <div class="max-w-0 overflow-hidden user-center-label uppercase">
              <span class="pl-1 text-[10px]">{{ $t("logout") }}</span>
            </div> -->
          </div>
        </div>
      </div>
      <div
        v-if="!auth"
        class="rounded-l-full w-full h-full absolute right-0 top-0"
        style="background-color: rgba(0, 0, 0, 0.5)"
      ></div>
      <div
        v-if="!auth"
        class="absolute top-[50%] translate-y-[-50%] left-[50%] translate-x-[-50%]"
      >
        {{ $t("Please Login before using user center") }}
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import useMenu from "@/composables/useMenu";
import { useHeaderComponent } from "@/composables/useTheme";
import { store } from "~/store";
import { memberMessageStore } from "~~/store/member-message";

const isTinyUserCenterEnabled = ref(false);
const route = useRoute();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const isHasUnreadMessage = computed(() => {
  return memberMessageStore.getters.isHasUnreadMessage;
});
const { fetchMessages } = useMessage();
const tiggerTinyUserCenter = () => {
  isTinyUserCenterEnabled.value = !isTinyUserCenterEnabled.value;
};
onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});

const { auth, isReferralV2Enabled, logout } = useHeaderComponent();
const {
  isCashPlayer,
  isShowDepositWithdrawal,
  isShowPromotion,
  isShowReferral,
} = useMenu();
const tabs = reactive([
  {
    to: "/deposit",
    label: "deposit",
    icon: "icon-deposit",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  {
    to: "/withdrawal",
    label: "withdrawal",
    icon: "icon-withdraw",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  { to: "/wallet", label: "wallet", icon: "icon-wallet-v2", display: true },
  { to: "/account", label: "account", icon: "icon-account-v2", display: true },
  {
    to: "/transaction-history",
    label: "statement",
    icon: "icon-transaction",
    display: true,
  },
  {
    to: "/bet-history",
    label: "bet_history",
    icon: "icon-bethistory-v2",
    display: true,
  },
  {
    to: "/my-promotion",
    label: "promotion",
    icon: "icon-promotion-v2",
    display: isShowPromotion.value,
  },
  {
    to: "/referral",
    label: "referral",
    icon: "icon-referral",
    display:
      isCashPlayer.value &&
      isShowReferral.value &&
      !isReferralV2Enabled.value &&
      isShowReferralPage.value,
  },
  {
    to: "/referral-v2",
    label: "referral",
    icon: "icon-referral",
    display: isReferralV2Enabled.value && isShowReferralPage.value,
  },
  // {
  //   to: "/help-center",
  //   label: "help_center",
  //   icon: "icon-aboutus",
  //   display: true,
  // },
  {
    to: "/messages",
    label: "messages",
    icon: "icon-message",
    display: true,
  },
]).filter((p) => p.display);
</script>
<style lang="scss">
.tiny-user-center {
  display: flex;
  align-items: center;
  flex-direction: row-reverse;
  position: relative;
  .user-center-container {
    background: linear-gradient(rgba(0, 0, 0, 0.35), rgba(0, 0, 0, 0.35)),
      linear-gradient(var(--background5), var(--background5));
    display: grid;
    align-items: center;
    height: 100%;
    white-space: nowrap;
    max-width: 0;
    overflow: hidden;
    transition: max-width 0.5s;
  }
  .user-center-container-active {
    max-width: 1000px;
  }
  .tiny-button {
    width: 32px;
    height: 32px;
    background-color: var(--background5);
    border-radius: 50%;
    rotate: 90deg;
    cursor: pointer;
    transition: rotate 0.3s;
    position: relative;
    z-index: 99;
  }
  .tiny-button-rotate {
    rotate: 0deg;
  }
  .tiny-dot {
    width: 2px;
    height: 2px;
    border-radius: 50%;
    background-color: var(--text5);
  }
  .tiny-dot-unread-message {
    position: absolute;
    top: -2px;
    right: -2px;
    width: 4px;
    height: 4px;
    border-radius: 50%;
    background: var(--failure);
    z-index: 100;
  }
  .user-center-container {
    backdrop-filter: blur(5px);
    transition: max-width 0.5s;
    svg {
      opacity: 0.8;
      fill: var(--text5) !important;
      color: var(--text5) !important;
    }
    .el-tooltip__trigger {
      svg {
        fill: var(--text5) !important;
        color: var(--text5) !important;
      }
      outline: unset;
      &:hover {
        opacity: 1;
        svg {
          opacity: 1;
        }
      }
    }
    .user-center-label {
      color: var(--text5);
    }
  }
  .user-center-element:not(:last-child) {
    border-right: solid var(--border) 1px;
  }
  .custom-backdrop-blur {
    -webkit-filter: blur(1.5px);
  }
  .user-center-element .user-center-label {
    transition: max-width 0.5s, opacity 0.3s ease-in;
    opacity: 0;
  }
}
.has-unread-message::before {
  content: "";
  position: absolute;
  top: 1px;
  left: 23px;
  width: 8px;
  height: 8px;
  border-radius: 50%;
  background: var(--failure);
  z-index: 100;
}
.tiny-user-center-tooltip {
  background: transparent !important;
  border: unset !important;
  border-radius: 9px;
  padding: 4px 8px;
  line-height: 14.05px;
  transform: translateY(10px);
  top: -10px !important;
  &::before {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background: linear-gradient(
        0deg,
        rgba(255, 255, 255, 0.05) 0%,
        rgba(255, 255, 255, 0.05) 100%
      ),
      var(--background5) !important;
    z-index: -1;
    border-radius: 9px;
  }
  .el-popper__arrow {
    display: none;
  }
}
</style>
